import numpy

from matrix import Matrix


class Vector(Matrix):
    def __init__(self, data: list | int):
        """

        :type data: list | int
        """
        if isinstance(data, list):
            super().__init__(data, (len(data), 1))
        elif isinstance(data, int):
            self.__init__([0] * data)
        else:
            raise ValueError("data must be a list or an integer for dimension")

    def get_dimension(self):
        return super().shape()[0]

    def __mul__(self, other):
        if isinstance(other, Vector):
            return (super().transpose().__mul__(other))[0][0]
        elif isinstance(other, int) or isinstance(other, float):
            return super().__mul__(other)
        else:
            raise ValueError("A vector can only be multiplied with an vector (dot product) or a scalar")

    def __rmul__(self, other):
        return self * other

    def norm(self, **kwargs):
        return super().norm()

    def normalize(self):
        return self / self.norm()
